<?php
/*********************************************************************************/
/*     Copyright (C) 2004-2005 Jean-Sbastien H. ( ED ) ( Livebox-script.com )   */
/*                                                                               */
/*     This file is part of Uptime Script                                        */
/*                                                                               */
/*     Uptime Script is free software; you can redistribute it and/or modify     */
/*     it under the terms of the GNU General Public License as published by      */
/*     the Free Software Foundation; either version 2 of the License, or         */
/*     (at your option) any later version.                                       */
/*                                                                               */ 
/*     Uptime Script is distributed in the hope that it will be useful,          */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */ 
/*     GNU General Public License for more details.                              */
/*                                                                               */
/*     You should have received a copy of the GNU General Public License         */ 
/*     along with Uptime Script; if not, write to the Free Software              */
/*     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA */
/*********************************************************************************/
/*                                                                               */
/*         Fichier lib/sagem.php                                        */
/*         Cr le 31 aout 2006                                                  */
/*                                                              				 */
/*         Derniere modification: 31 aout 2006   - v4.0.0.alpha-rev9             */
/*                                                                               */
/*********************************************************************************/
abstract class AbstractPage {
	
	public $titre;
	public $version = "v4.0.0.alpha-rev12";
	
	public function __construct($titre="Uptime Script") {

		$this->titre = $titre;
		// Fonction destine aux traitements de formulaires
		$this->prepare();
		// Affichage de la page

		echo "<?xml version='1.0' encoding='iso-8859-1'?>\n";
		
		echo "	 <!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.1//EN'";
    	echo "	 		   'http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd'>\n";
		echo "<html xmlns='http://www.w3.org/1999/xhtml' xml:lang='en' >\n";
		echo "<head>\n";
		echo $this->displayHEAD();
		echo "</head>\n";		
		echo "<body>\n";
		echo "<div id='content'>\n";
		echo $this->displayBODY();
		echo $this->displayFooter();
		echo "</div>\n";
		echo "</body>\n";
		echo "</html>\n";

	}
	
	public function displayHEAD() {
	 		  $toDisplay = $this->displayHEADLink();
	 		  $toDisplay .= "<script type='text/javascript'>\n";
	 		  $toDisplay .= $this->displayHEADJavaScript();
	 		  $toDisplay .= "</script>\n";
	 		  $toDisplay .= "<title>Uptime Script</title>\n";
	 		  return $toDisplay;
	}
	 
	public function displayBODY() {
	 		  $toDisplay = "<div id='header'>\n";
	 		  			 $toDisplay .= "<div id='logo' onclick='window.open(\"index.php\",\"_self\")'>\n";
	 		  			 		//	$toDisplay .= "<img src='logoinventel.gif' alt='Livebox' />";
	 		  			 $toDisplay .= "</div>\n";	 
	 		  			 $toDisplay .= "<div id='infoLivebox'>\n";
	 		  			 // On ne met rien la dedans, le javascript s'en charge
	 		  			 $toDisplay .= "</div>\n";									  
	 		  $toDisplay .= "</div>\n";
	 		  $toDisplay .= "<div id='cadre'>\n";
	 		  $toDisplay .= $this->displayContent();
	 		  $toDisplay .= "</div>\n";	 		  
	 		  return $toDisplay;
	}
	
	public function displayHEADLink() {
	 		  $toDisplay = "<script type='text/javascript' src='includes/javascript.js'></script>\n";
	 		  $toDisplay .= "<link rel='stylesheet' type='text/css' href='includes/style.css' media='screen' title='Normal' />\n";
	 		  $toDisplay .= "<meta http-equiv='refresh' content='300' />\n";
	 		  return $toDisplay;
	}		 
	public function displayHEADJavaScript() {
	 		  $toDisplay = "window.onload = function() { charger(); }";
	 		  return $toDisplay;
	}
	public abstract function displayContent();
	 
	public abstract function prepare();
	
	public function checkUpdate($old_version) {
		   $fp = @fsockopen("www.livebox-script.com",80,$errno,$errdescr,3);
		   $doc = new DOMDocument();
		   if($fp && $doc->load("http://www.livebox-script.com/updatecheck/update.xml"))//&& $file = @fopen("http://www.livebox-script.com/updatecheck/update.xml",'r')) 
		   { 
		   	     
				 $old_version = trim($old_version);
				 $new_version = trim($doc->getElementsByTagName('Version')->item(0)->nodeValue);
			   	 if(strlen($new_version) < strlen($old_version))
			   	 {
			           $temp = $old_version;
			      	   $old_version = $new_version;
			      	   $new_version = $temp;
			      	   
			      }			   			   
			   	  if(eregi($new_version,$old_version) == FALSE)			   			   	 
				      return "<span class='maj'><a href='".trim($doc->getElementsByTagName('newsURL')->item(0)->nodeValue)."'>Mise a jour disponible</a></span>";
			     
		   }
		   return "";
	}

	public function displayFooter() {
	 		  $toDisplay = "<div id='footer'>\n";
	 		  $toDisplay .= "<p>[ ".$this->version." ]</p>\n";
	 		  $toDisplay .= $this->checkUpdate($this->version);
	 		  $toDisplay .= "</div>\n";
	 		  return $toDisplay;
	}
    public function convert_months($value)
    {
        $months = array(
     	'01' => I10N_MONTH_JANV,
     	'02' => I10N_MONTH_FEV,
     	'03' => I10N_MONTH_MARS,
     	'04' => I10N_MONTH_AVR,
     	'05' => I10N_MONTH_MAI,
     	'06' => I10N_MONTH_JUIN,
     	'07' => I10N_MONTH_JUIL,
     	'08' => I10N_MONTH_AOUT,
     	'09' => I10N_MONTH_SEPT,
     	'10' => I10N_MONTH_OCT,
     	'11' => I10N_MONTH_NOV,
     	'12' => I10N_MONTH_DEC
		);
		if(is_numeric($value))
		{
		    return $months[$value];
		}    
    } // fin months	
    public function convert_day($value)
    {
        $day = array(1 => I10N_DAY_LUN,I10N_DAY_MAR,I10N_DAY_MER,I10N_DAY_JEU,I10N_DAY_VEN,I10N_DAY_SAM,I10N_DAY_DIM);
		if(is_numeric($value))
		{
		    return $day[$value];
		}    
    } // fin months	 
	public  function week_dates($week,$year) {
  	  	// http://fr2.php.net/manual/fr/function.strtotime.php
   		// On rcupre le premier jour de l'anne
   		$first_day = mktime(0,0,0,1,1,$year);
		
		// On rcupre la semaine correspondante
   		$first_week = date("W",$first_day);

   		// 3 cas
		if($first_week == 1) {
			$week--;
		}
   		
		$timestamp = strtotime("+$week week",$first_day);

   		// Adjust to Monday of that week
		$what_day = date("w",$timestamp); // I wanted to do "N" but only version 4.3.9 is installed :-(
   		if ($what_day==0) {
			// actually Sunday, last day of the week. FIX;
			$timestamp = strtotime("-6 days",$timestamp);
   		} elseif ($what_day > 1) {
       		$what_day--;
       		$timestamp = strtotime("-$what_day days",$timestamp);
   		}

		$week_dates = array(
			0=>$timestamp,
			strtotime("+1 day",$timestamp),
   			strtotime("+2 day",$timestamp),
			strtotime("+3 day",$timestamp),
			strtotime("+4 day",$timestamp),
			strtotime("+5 day",$timestamp),
			strtotime("+6 day",$timestamp)
		);
        rsort($week_dates);
		return($week_dates);
	}	   
}

?>